
public class MergeSort {
	
	public static void main(String[] args) {
		int[] arr = {5,3,7,2,1,4,5,4};
		
		arr = mergesort(arr);
		
		for(int i : arr)
			System.out.print(i + " ");
	}
	
	public static int[] mergesort(int[] m) {
		if(m.length <= 1)
			return m;
		
		int nLeft = m.length / 2;
		int nRight = m.length - nLeft;
		
		int[] left = new int[nLeft];
		int[] right = new int[nRight];
		
		for(int i = 0; i < nLeft; ++i) {
			left[i] = m[i];
		}
		
		for(int i = 0; i < nRight; ++i) {
			right[i] = m[nLeft + i];
		}
		
		return merge(mergesort(left), mergesort(right));
	}
	
	public static int[] merge(int[] left, int[] right) {
		int[] result = new int[left.length + right.length];
		
		int i = 0;
		int j = 0;
		int k = 0;
		
		while(i < left.length && j < right.length) {
			if(left[i] < right[j]) {
				result[k] = left[i++];
			} else {
				result[k] = right[j++];
			}
			
			++k;
		}
		
		while(i < left.length) {
			result[k] = left[i];
			
			++i;
			++k;
		}
		
		while(j < left.length) {
			result[k] = right[j];
			
			++j;
			++k;
		}
		
		return result;
	}
}
